unit DebugForm;
{ Test noddy for yacc generated parser - debug window.			}
{ Author C.P.Osborne.							}
{ Modified:								}
{	11/09/2000	CPO	Created.				}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, LexFile;

type
  TfrmDebug = class(TForm)
    DebugMemo: TMemo;
  private
    OPStr	: String;
  public
    function OPHandler( mode : TFmode; C : Char ) : Char;
    procedure Flush;
  end;

var
  frmDebug: TfrmDebug;

implementation

{$R *.DFM}

{ Flush any part string to memo.					}
procedure TfrmDebug.Flush;
begin
  if OPStr <> '' then
  begin
    DebugMemo.Lines.Add( OPStr );
    OPStr := '';
  end;
end;	{ Flush	}

{ Output data handler.							}
function TfrmDebug.OPHandler(mode: TFmode; C: Char): Char;
begin
  Result := #0;

  case mode of
    tfEOF : Result := #1;		{ Never end of file		}
    tfGet : raise ELFException.Create('Not an input file');
    tfPut : begin
	      if C in [#10,#13] then
	      begin
		DebugMemo.Lines.Add( OPStr );
		OPStr := '';
	      end else OPStr := OPStr + C;
	    end;
  end;
end;	{ OPHandler	}

end.
