  (* Lexical analyzer word count test
     Author C.P.Osborne
     Modified:
	25/09/2000	CPO	Created
  *)

%{
var
  LineCount	: Integer;
  WordCount	: Integer;
  CharCount	: Integer;
  CommentCount	: Integer;
%}
word				[^ \t\n]+
eol				\n

%x COMMENT

%%
\/\/		begin
		  Inc( CommentCount );
		  start( COMMENT );
		end;
{word}		begin
		  Inc(WordCount);
		  CharCount := CharCount + yyleng;
		end;
{eol}		begin
		  Inc( CharCount );
		  Inc( LineCount );
		end;
.		begin
		  Inc( CharCount );
		end;
<COMMENT>{word}	;
<COMMENT>{eol}	start( 0 );
<COMMENT>.	;
%%